﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows;
using Telerik.Windows.Controls;
using System.Collections;
using System.Diagnostics;


namespace SilverlightApplication1
{
	public partial class MainPage : System.Windows.Controls.UserControl
	{
		private RadWindow parent = null;

		public MainPage()
		{
			InitializeComponent();
			listBox1.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo));
			listBox1.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery));
		}

		private void OnDropInfo(object sender, DragDropEventArgs e)
		{
			var destination = e.Options.Destination;
			if (e.Options.Status == DragStatus.DropComplete && destination is AppointmentDialogWindow)
			{
				AppointmentDialogWindow appointmentDialogWindow = this.parent.Content as AppointmentDialogWindow;
				// add your logic here
				MessageBox.Show("Drop Target: AppointmentDialogWindow");
			}
		}

		private void OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			var destination = e.Options.Destination;
			if (e.Options.Status == DragStatus.DropDestinationQuery && destination is AppointmentDialogWindow)
			{
				e.QueryResult = true;
				e.Handled = true;
			}
		}
		private void OnDragInfo(object sender, DragDropEventArgs e)
		{
			if (e.Options.Status == DragStatus.DragComplete)
			{
				// If you want to remove the dragged item from the listbox, you can uncomment the line bellow.
				//listBox1.Items.Remove(e.Options.Source);
			}
		}
		private void OnDragQuery(object sender, DragDropQueryEventArgs e)
		{
			if (e.Options.Status == DragStatus.DragQuery)
			{
				var draggedListBoxItem = e.Options.Source as System.Windows.Controls.ListBoxItem;
				e.Options.DragCue = draggedListBoxItem.Content;
				e.Options.Payload = draggedListBoxItem.Content;
			}

			e.QueryResult = true;
			e.Handled = true;
		}

		private void Control_Loaded(object sender, RoutedEventArgs e)
		{
			parent = (sender as FrameworkElement).ParentOfType<RadWindow>();
			parent.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			parent.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
		}
	}
}
